
; ȏR[h
SelfModifyingCode_Base:

ClearExtWorkMemory:
	ldy	#$60
	lda	#$00
	tax
.1:
	sty	SMCL(.2+2)
.2:
	sta	$6000,x
	inx
	bne	.2
	iny
	cpy	#$6c
	bne	.1
	rts

CopyStageIndex:
	ldx	#0
.1:
	lda	St1_Index,x
	sta	SEQ_TBL,x
	inx
	bne	.1

	lda	<PL_T
	and	#$06
	tax
	lda	SEQ_TBL_TALK,x
	sta	SMCL(.2+1)
	lda	SEQ_TBL_TALK+1,x
	sta	SMCL(.2+2)
	ldx	#0
.2:
	lda	St1_Index,x
	sta	SEQ_TBL_TALK,x
	inx
	cpx	#16
	bcc	.2
	rts

Enemy_Alloc:
	ldx	SMCL(Enemy_Alloc_X+1)
Enemy_Alloc_Loop:
	lda	EN_X,x
	bmi	Enemy_Alloc_Found
	cpx	<EN_MAX_M2
	bcc	.2
	ldx	#$fe
.2:
	inx
	inx
Enemy_Alloc_X:
	cpx	#0
	bne	Enemy_Alloc_Loop

	lda	<EN_MAX_M2
	cmp	#$3e
	bcc	Enemy_Alloc_Expand
	.db	$24	; bit <$b8 (set v-flag)
Enemy_Alloc_Found:
	clv
	lda	Int+2,x
	cpx	<EN_MAX_M2
	bcc	.9
	lda	#$00
.9:
	sta	SMCL(Enemy_Alloc_X+1)
	rts
Enemy_Alloc_Expand:
	tax
;	clc
	adc	#8
	sta	<EN_MAX_M2
	cpx	<EN_MAX_M2+1
	bne	.12
	sta	<EN_MAX_M2+1
.12:
	inx
	inx
	lda	#$03
	sta	EN_DELAY_LC
	jmp	SMCL(Enemy_Alloc_Loop)

	; a:x pos
	; y:y pos
	; result y:enemy index
Enemy_SearchNear:
	stx	SMCL(.restore_x+1)
	lsr	a
	sta	SMCL(.sub_x+1)
	tya
	lsr	a
	sta	SMCL(.sub_y+1)

	ldy	#$ff
	sty	SMCL(.cmp_max+1)
	ldx	<EN_MAX_M2+1
.1:
	lda	EN_S,x
	and	#$40
	bne	.4

	lda	EN_X,x
	bmi	.4
	lsr	a
	sec
.sub_x:
	sbc	#0
	bpl	.2
	eor	#$ff
;	clc
	adc	#1
.2:
	sta	SMCL(.add_xdif+1)
	lda	EN_Y,x
	lsr	a
	sec
.sub_y:
	sbc	#0
	bpl	.3
	eor	#$ff
;	clc
	adc	#1
.3:
	clc
.add_xdif:
	adc	#0
.cmp_max
	cmp	#$ff
	bcs	.4
	sta	SMCL(.cmp_max+1)
	ldy	Int,x
.4:
	dex
	dex
	bpl	.1
.restore_x:
	ldx	#0
	rts

Shot_Alloc:
	ldx	SMCL(Shot_Alloc_X+1)
Shot_Alloc_Loop:
	lda	SH_X,x
	bmi	Shot_Alloc_Found
	cpx	<SH_MAX_M2
	bcc	.2
	ldx	#$fe
.2:
	inx
	inx
Shot_Alloc_X:
	cpx	#0
	bne	Shot_Alloc_Loop

	lda	<SH_MAX_M2
	cmp	#$fe
	bcc	Shot_Alloc_Expand
	.db	$24	; bit <$b8 (set v-flag)
Shot_Alloc_Found:
	clv
	lda	Int+2,x
	cpx	<SH_MAX_M2
	bcc	.9
	lda	#$00
.9:
	sta	SMCL(Shot_Alloc_X+1)
	rts
Shot_Alloc_Expand:
	tax
;	clc
	adc	#64
	sta	<SH_MAX_M2
	cpx	<SH_MAX_M2+1
	bne	.12
	sta	<SH_MAX_M2+1
	stx	SMCL(.11+1)
	jsr	Proc_UpdateShotIndex
.11:
	ldx	#0
.12:
	inx
	inx
	lda	#$03
	sta	SH_DELAY_LC
	jmp	SMCL(Shot_Alloc_Loop)

Shot_Draw:
	ldx	SMCL(Shot_Draw_X+1)
	lda	<SPR_INX
	beq	Shot_Draw_Exit
Shot_Draw_Loop:
	lda	SH_X,x
	bmi	Shot_Draw_Skip
	sta	<FNC_ARG

	lda	SH_Y,x
	sta	<FNC_ARG+1

	lda	SH_T,x
	and	#$0f
	asl	a
;	clc
	adc	#LOW(FN_SH_SPR)
;	sta	<USR_FNC
	sta	SMCL(.1+1)

	ldy	SH_OA,x
	lda	SH_OT,x
	stx	SMCL(Shot_Draw_None+1)
;	jsr	USR_FNC-1
.1:
	jmp	[FN_SH_SPR]

Shot_Draw_Next:
	lda	Int+4,x
Shot_Draw_Ret:
	sta	<SPR_INX
Shot_Draw_None:
	ldx	#$00
	tay
	beq	Shot_Draw_Exit
Shot_Draw_Skip:
	lda	SH_INX+14,x
	tax
Shot_Draw_X:
	cpx	#0
	bne	Shot_Draw_Loop
Shot_Draw_Exit:
	lda	SH_INX+10,x
	sta	SMCL(Shot_Draw_X+1)
	rts

	; x : shot index
Shot_Hitcheck_Enemy:
	lda	SH_X,x
	clc
	adc	#6
	sta	SMCL(.sub_x+1)
	lda	SH_Y,x
	clc
	adc	#6
	sta	SMCL(.sub_y+1)
	lda	SH_D,x
	and	#$7f
	sta	SMCL(.sub_damage+1)
	eor	SH_D,x
	sta	SMCL(.or_cherry+1)
	ldx	<EN_MAX_M2+1
.1:
	lda	EN_X,x
	bmi	.2

	sec
.sub_x:
	sbc	#0
	cmp	#$f4
	bcc	.2

	lda	EN_Y,x
	sec
.sub_y:
	sbc	#0
	cmp	#$f4
	bcc	.2

	lda	EN_S,x
	and	#$40
	beq	.3
.2:
	dex
	dex
	bpl	.1
	rts

.3:
	lda	EN_LIFE,x
;	sec
.sub_damage:
	sbc	#0
	sta	EN_LIFE,x
	beq	.4
	bpl	.5
.4:
	lda	EN_S,x
	ora	#$80
	sta	EN_S,x
.5:
	lda	EN_T,x
	and	#$c0
.or_cherry:
	ora	#$00
	beq	.6
;	lda	#1
	lda	#5
	jsr	Util_AddCherry
.6:

	lda	#1
	ldy	#0
	jsr	Util_AddScore

	ldx	<SH_FNC
	lda	SH_CB+1,x
	beq	.7
;	jsr	SH_FNC-1
	jmp	SH_FNC-1
	; CBŃVbg̔jI邽
	; ɖ߂ĂKv͖
.7:
	lda	#$ff
	sta	SH_X,x
	rts

	; a          : param addr lo
	; y          : param addr hi
	; x          : 
	; c flag     : snipe
	; FNC_ARG    : 0xxxxxxx x:x pos
	; FNC_ARG+1  : yyyyyyyy y:y pos
	; param  + 0 : epp000aa
	;              e:play se
	;              p:base pos (00:fnc arg 01:fnc arg 10:enemy pos 11:shot pos)
	;              a:base angle (00:zero 01:snipe 10:enemy angle 11:shot angle)
	; param+x+ 0 : 00000000 end
	;              00nnnnnn add shot
	;              10cisaht set format
	;              11cisaht default value
	;              n:shot num c:cb i:inc s:speed a:angle h:shape t:type
	; param+x+ 1 : ----tttt t:shot type     (type enable)
	; param+x+ 2 : --sssccc s:shape c:color (shape enable)
	; param+x+ 3 : aaaaaaaa a:angle         (angle enable)
	; param+x+ 4 : --ssssss s:speed         (speed enable)
	; param+x+ 5 : vvvvvvvv v:velocity inc  (inc enable)
	; param+x+ 6 : aaaaaaaa a:angle inc     (inc enable)
	; param+x+ 7 : ssssssss s:speed inc     (inc enable)
	; param+x+ 8 : llllllll l:cb lo addr    (cb enable)
	; param+x+ 9 : hhhhhhhh l:cb hi addr    (cb enable)
	; param+x+10 : llllllll l:cb cnt        (cb enable)
	;
	; FNC_WORK   : use sub func
	; FNC_WORK+1 : use sub func
	; FNC_WORK+2 : use sub func
	; FNC_WORK+3 : loop counter
	; FNC_WORK+4 : param ptr lo
	; FNC_WORK+5 : param ptr hi
	; FNC_WORK+6 : format flag work
	; FNC_WORK+7 : format flag
Shot_Normal_Create:
	stx	SMCL(.restore_x+1)
	sta	<FNC_WORK+4
	sty	<FNC_WORK+5

	lda	$9fff
	sta	SMCL(.restore_bank+1)
	ldy	<FNC_WORK+5
	lda	Xcn,y
	and	#$0e
	lsr	a
;	clc
	adc	#BANK_PRG_BLTPAT
	jsr	SetPrgBankA
	lda	<FNC_WORK+5
	and	#$1f
	ora	#$80
	sta	<FNC_WORK+5

	ldy	#0
	lda	[FNC_WORK+4],y
	bpl	.1
	ldy	#SE_EN_SHOT1
	cpy	<SND_SE
	bcc	.1
	sty	<SND_SE
.1:
	asl	a
	bpl	.3
	cmp	#$c0
	bcs	.2
	ldy	EN_X,x
	sty	<FNC_ARG
	ldy	EN_Y,x
	sty	<FNC_ARG+1
	bcc	.3	; same as jmp
.2:
	ldy	SH_X,x
	sty	<FNC_ARG
	ldy	SH_Y,x
	sty	<FNC_ARG+1
.3:
	and	#$06
	lsr	a
	tay
	lda	SMCL(.jmptbl),y
	sta	SMCL(.jmp+1)
.jmp:
	bcc	.jmp	; same as jmp
.jmptbl:
	.db	.angle_zero-.jmptbl
	.db	.angle_snipe-.jmptbl
	.db	.angle_enemy-.jmptbl
	.db	.angle_shot-.jmptbl
.angle_zero:
	lda	#0
	beq	.4	; same as jmp
.angle_enemy:
	lda	EN_A,x
	bcc	.4	; same as jmp
.angle_shot:
	lda	SH_A,x
	bcc	.4	; same as jmp
.angle_snipe:
	lda	<PL_X
	sta	<FNC_ARG+2
	lda	<PL_Y
	sta	<FNC_ARG+3
	jsr	Util_GetAngle
.4:
	sta	SMCL(.base_angle+1)

	lda	#$02
	sta	SMCL(.type+1)
	ldy	#0
;	sty	SMCL(.shape+1)
;	sty	SMCL(.angle+1)
;	sty	SMCL(.speed+1)
	sty	SMCL(.vc+1)
	sty	SMCL(.ia+1)
	sty	SMCL(.is+1)
	sty	SMCL(.cb_lo+1)
	sty	SMCL(.cb_hi+1)
	sty	SMCL(.cb_cnt+1)
	iny
	bne	.6	; same as jmp
.5:
	iny
	sta	<FNC_WORK+6
	bit	<FNC_WORK+6
	bvs	.11	; set default
	; set format
	sta	<FNC_WORK+7
.6:
	; parse
	lda	[FNC_WORK+4],y
	beq	.8
	bmi	.5
	iny
	sta	<FNC_WORK+3
.7:
	jsr	SMCL(Shot_Alloc)
	bvc	.10
.8:
.restore_bank:
	lda	#0
	jsr	SetPrgBankA
.restore_x:
	ldx	#0
	rts
.10:
	; add shot
	lda	<FNC_WORK+7
	sta	<FNC_WORK+6
.11:
	lsr	<FNC_WORK+6
	bcc	.12
	lda	[FNC_WORK+4],y
	sta	SMCL(.type+1)
	iny
.12:
	lsr	<FNC_WORK+6
	bcc	.13
	lda	[FNC_WORK+4],y
	sta	SMCL(.shape+1)
	iny
.13:
	lsr	<FNC_WORK+6
	bcc	.14
	lda	[FNC_WORK+4],y
	sta	SMCL(.angle+1)
	iny
.14:
	lsr	<FNC_WORK+6
	bcc	.15
	lda	[FNC_WORK+4],y
	sta	SMCL(.speed+1)
	iny
.15:
	lsr	<FNC_WORK+6
	bcc	.16
	lda	[FNC_WORK+4],y
	sta	SMCL(.vc+1)
	iny
	lda	[FNC_WORK+4],y
	sta	SMCL(.ia+1)
	iny
	lda	[FNC_WORK+4],y
	sta	SMCL(.is+1)
	iny
.16:
	lsr	<FNC_WORK+6
	bcc	.17
	lda	[FNC_WORK+4],y
	sta	SMCL(.cb_lo+1)
	iny
	lda	[FNC_WORK+4],y
	sta	SMCL(.cb_hi+1)
	iny
	lda	[FNC_WORK+4],y
	sta	SMCL(.cb_cnt+1)
	iny
.17:
	bvs	.6
	sty	SMCL(.restore_y+1)
.shape:
	ldy	#0
	lda	PLC_SH_COLOR,y
	sta	SH_D,x
	tay
.angle:
	lda	#0
	clc
.base_angle
	adc	#0
	sta	SH_A,x
	jsr	Shot_Normal_SetObjData
.speed:
	lda	#0
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

.type:
	lda	#$02
	sta	SH_T,x
	lda	<FNC_ARG
	sta	SH_X,x
	lda	<FNC_ARG+1
	sta	SH_Y,x
	lda	#0
	sta	SH_U,x
	sta	SH_V,x
.vc:
	lda	#0
	sta	SH_VC,x
	sta	SH_VN,x
.is:
	lda	#0
	sta	SH_IS,x
.ia:
	lda	#0
	sta	SH_IA,x
.cb_lo:
	lda	#0
	sta	SH_CB,x
.cb_hi:
	lda	#0
	sta	SH_CB+1,x
.cb_cnt:
	lda	#0
	sta	SH_FC,x
.restore_y:
	ldy	#0
	dec	<FNC_WORK+3
	beq	.19
	jmp	SMCL(.7)
.19:
	jmp	SMCL(.6)

	; x: block (0-2)
	; work reg: a x y
Vcmd_SetLayerData_Block_Back:
	lda	#BANK_PRG_BSTTRN
	jsr	SetPrgBankA

	txa
	eor	<IRQ_MODE
	and	#$f7
	eor	<IRQ_MODE
	tay

	txa
	asl	a
	asl	a
	tax
	jsr	Vcmd_SetLayerData_Block_Burst

	lda	SEQ_BANK_BG
	jmp	SetPrgBankA
;		lda	BGS_LayerAddr_L,x
;		sta	SMCL(.3+1)
;		lda	BGS_LayerAddr_H,x
;		sta	SMCL(.4+2)
;		lda	<IRQ_MODE
;		and	#$08
;		bne	.1
;		inx
;		inx
;		inx
;	.1:
;		lda	BGS_PPU_HTbl_L,x
;		sta	SMCL(.6+1)
;		lda	BGS_PPU_HTbl_H,x
;		sta	SMCL(.6+2)
;		lda	BGS_PPU_LTbl_L,x
;		sta	SMCL(.7+1)
;		lda	BGS_PPU_LTbl_H,x
;		sta	SMCL(.7+2)
;
;		ldy	#7
;		ldx	#160
;	.2:
;		lda	Xcn,y		; 8*4 clk
;	.3:
;		ora	#LOW(BGS_LAYER)	; 8*2 clk
;		sta	SMCL(.4+1)	; 8*4 clk
;		sty	SMCL(.5+1)	; 8*4 clk
;		ldy	#15		; 8*2 clk
;	.4:
;		lda	BGS_LAYER,y	; 8*16*4 clk
;		dex			; 8*16*2 clk
;		sta	VCMD_DATA,x	; 8*16*4 clk
;		dey			; 8*16*2 clk
;		bpl	.4		; 8*16*3-1 clk
;	.5:
;		ldy	#$00		; 8*2 clk
;		lda	Int-4,x		; 8*4 clk
;		tax			; 8*2 clk
;		lda	#16		; 8*2 clk
;		sta	VCMD_DATA,x	; 8*4 clk
;		lda	#$00		; 8*2 clk
;		sta	VCMD_DATA+1,x	; 8*4 clk
;	.6:
;		lda	BGS_PPUAddr_N_H,y	; 8*4 clk
;		sta	VCMD_DATA+2,x		; 8*4 clk
;	.7:
;		lda	BGS_PPUAddr_N_L,y	; 8*4 clk
;		sta	VCMD_DATA+3,x		; 8*4 clk
;		dey				; 8*2 clk
;		bpl	.2			; 8*3-1 clk
;		lda	#160
;		sta	<VCMD_SIZE
;		rts
;						; 8*16 + 8*16*15-1 + 8*41-1
;						; 128 + 128*15-1 + 328-1
;						; 456 + 1920 - 2 = 2374clk = 22Line

	; a : item
	; x
	; y
	; FNC_ARG+4 : area_width/2
	; FNC_ARG+5 : area_height/2
	; FNC_ARG+6 : -area_width
	; FNC_ARG+7 : -area_height
	; use reg: a y
	; use work: 0-6
	; use arg:  0-7
Util_ResolveItem_Bound:
	sta	SMCL(.item+1)
	lda	<PL_X
	clc
	adc	<FNC_ARG+4
	sta	SMCL(.sub_x+1)
	lda	<PL_Y
	clc
	adc	<FNC_ARG+5
	sta	SMCL(.sub_y+1)
	stx	<FNC_WORK+6
	ldx	<SH_MAX_M2+1
.1:
	lda	SH_X,x
	bmi	.2

	sec
.sub_x:
	sbc	#0
	cmp	<FNC_ARG+6
	bcc	.2

	lda	SH_T,x
	and	#$0f
	cmp	#2
	bcc	.2

	lda	SH_Y,x
	sec
.sub_y:
	sbc	#0
	cmp	<FNC_ARG+7
	bcc	.2

.item:
	lda	#ITEM_BONUS
	jsr	Shot_Item_Resolve
.2:
	dex
	dex
	cpx	#$fe
	bcc	.1
	ldx	<FNC_WORK+6
	rts

SelfModifyingCode_End:

